# ACE_POSIX_Asynch_Read_Dgram Class Reference

This class is a factory for starting off asynchronous reads on a UDP socket. More...

`#include <POSIX_Asynch_IO.h>`

Inheritance diagram for ACE_POSIX_Asynch_Read_Dgram:

[legend]
Collaboration diagram for ACE_POSIX_Asynch_Read_Dgram:

[legend]
List of all members.

## Public Member Functions

| ACE_POSIX_Asynch_Read_Dgram (ACE_POSIX_Proactor *posix_proactor)
| Constructor.
virtual | ~ACE_POSIX_Asynch_Read_Dgram (void)
virtual ssize_t | recv (ACE_Message_Block *message_block, size_t &number_of_bytes_recvd, int flags, int protocol_family, const void *act, int priority, int signal_number)

## Protected Member Functions

| ACE_POSIX_Asynch_Read_Dgram (void)
| Do-nothing constructor.

## Detailed Description

This class is a factory for starting off asynchronous reads on a UDP socket.

Once <open> is called, multiple asynchronous <read>s can be started using this class. An ACE_Asynch_Read_Dgram::Result will be passed back to the <handler> when the asynchronous reads completes through the <ACE_Handler::handle_read_stream> callback.

## Constructor & Destructor Documentation

ACE_POSIX_Asynch_Read_Dgram::ACE_POSIX_Asynch_Read_Dgram | ( | ACE_POSIX_Proactor * | posix_proactor | ) |

| Constructor.

ACE_POSIX_Asynch_Read_Dgram::~ACE_POSIX_Asynch_Read_Dgram | ( | void |  | ) | `[virtual]`

ACE_POSIX_Asynch_Read_Dgram::ACE_POSIX_Asynch_Read_Dgram | ( | void |  | ) | `[protected]`

| Do-nothing constructor.

## Member Function Documentation

ssize_t ACE_POSIX_Asynch_Read_Dgram::recv | ( | ACE_Message_Block * | message_block,
|  | size_t & | number_of_bytes_recvd,
|  | int | flags,
|  | int | protocol_family,
|  | const void * | act,
|  | int | priority,
|  | int | signal_number
| ) | `[virtual]`

This method queues an asynchronous read. Up to message_block->total_size() bytes will be read and stored in the message_block beginning at its write pointer. The message_block write pointer will be updated to reflect any added bytes if the read operation is successful completed. Priority of the operation is specified by <priority>. On POSIX4-Unix, this is supported. Works like <nice> in Unix. Negative values are not allowed. 0 means priority of the operation same as the process priority. 1 means priority of the operation is one less than process. <signal_number> argument is a no-op on non-POSIX4 systems.

Note:
  Unlike the Windows version of this facility, no indication of immediate success can be returned, and number_of_bytes_read is never used.

- flags Not used.
- protocol_family Not used.
  Return values:

    | 0 | The IO will complete asynchronously.
    | -1 | There was an error; see `errno` to get the error code.

Implements ACE_Asynch_Read_Dgram_Impl.

The documentation for this class was generated from the following files:

- POSIX_Asynch_IO.h
- POSIX_Asynch_IO.cpp